{% extends '@EasyAdmin/default/layout.html.twig' %}

{% block title %}Suppliers schedule{% endblock %}

{% block content_title %}
    Suppliers schedule
{% endblock %}

{% block main %}
    <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.24.0/moment.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/eonasdan-bootstrap-datetimepicker/4.17.47/js/bootstrap-datetimepicker.min.js"></script>

    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datetimepicker/4.17.37/css/bootstrap-datetimepicker.min.css">

    <div class="container my-4">
        <div class="row">
            <div class="col-md-5">
                <div class="form-group">
                    <label for="selectSupplier" class="ml-0">Select supplier</label>
                    <select class="form-control" id="selectSupplier">
                        <option selected disabled>Select supplier</option>
                        {% for supplier in suppliers %}
                            <option {% if currentIdSupplier == supplier.id %}selected {% endif %}
                                    value="/suppliers/schedule/{{ supplier.id }}">{{ supplier.name }}</option>
                        {% endfor %}
                    </select>
                </div>
            </div>
        </div>

        {% if currentIdSupplier != null %}
            <div class="container">
                <form method="post" action="/suppliers/updateSuppliersSchedule/{{ currentIdSupplier }}"
                      id="change_supplier_schedule_form" data-supplier="{{ currentIdSupplier }}">

                    <div id="monday" class="my-5 day" data-day="1">
                        <h4 class="row mx-2">
                            <div class="custom-control custom-switch">
                                <input type="checkbox" class="custom-control-input switch_day"
                                       data-day="1"
                                       {% if scheduleData.mon[0] is not empty %}checked{% endif %} id="switchMonday">
                                <label class="custom-control-label" for="switchMonday"></label>
                            </div>
                            Monday
                        </h4>

                        <div class="form-row day_container">

                            <div class="col time_from">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="monday_from"
                                                   data-day="1"
                                                   placeholder="From"
                                                   readonly
                                                    {% if scheduleData.mon[0] is not empty %}
                                                value="{{ scheduleData.mon[0] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col time_to">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="monday_to"
                                                   data-day="1"
                                                   placeholder="To"
                                                   readonly
                                                    {% if scheduleData.mon[0] is not empty %}
                                                value="{{ scheduleData.mon[1] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>

                        </div>
                    </div>

                    <div id="tuesday" class="my-5 day" data-day="2">
                        <h4 class="row mx-2">
                            <div class="custom-control custom-switch">
                                <input type="checkbox" class="custom-control-input switch_day"
                                       data-day="2"
                                       {% if scheduleData.tue[0] is not empty %}checked{% endif %} id="switchTuesday">
                                <label class="custom-control-label" for="switchTuesday"></label>
                            </div>
                            Tuesday
                        </h4>
                        <div class="form-row day_container">
                            <div class="col time_from">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="tuesday_from"
                                                   data-day="2"
                                                   placeholder="From"
                                                   readonly
                                                    {% if scheduleData.tue[0] is not empty %}
                                                value="{{ scheduleData.tue[0] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col time_to">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="tuesday_to"
                                                   data-day="2"
                                                   placeholder="To"
                                                   readonly
                                                    {% if scheduleData.tue[0] is not empty %}
                                                value="{{ scheduleData.tue[1] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div id="wednesday" class="my-5 day" data-day="3">
                        <h4 class="row mx-2">
                            <div class="custom-control custom-switch">
                                <input type="checkbox" class="custom-control-input switch_day"
                                       data-day="3"
                                       {% if scheduleData.wed[0] is not empty %}checked{% endif %} id="switchWednesday">
                                <label class="custom-control-label" for="switchWednesday"></label>
                            </div>
                            Wednesday
                        </h4>
                        <div class="form-row day_container">
                            <div class="col time_from">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="wednesday_from"
                                                   data-day="3"
                                                   placeholder="From"
                                                   readonly
                                                    {% if scheduleData.wed[0] is not empty %}
                                                value="{{ scheduleData.wed[0] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col time_to">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="wednesday_to"
                                                   data-day="3"
                                                   placeholder="To"
                                                   readonly
                                                    {% if scheduleData.wed[0] is not empty %}
                                                value="{{ scheduleData.wed[1] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div id="thursday" class="my-5 day" data-day="4">
                        <h4 class="row mx-2">
                            <div class="custom-control custom-switch">
                                <input type="checkbox" class="custom-control-input switch_day"
                                       data-day="4"
                                       {% if scheduleData.thu[0] is not empty %}checked{% endif %} id="switchThursday">
                                <label class="custom-control-label" for="switchThursday"></label>
                            </div>
                            Thursday
                        </h4>
                        <div class="form-row day_container">
                            <div class="col time_from">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="thursday_from"
                                                   data-day="4"
                                                   placeholder="From"
                                                   readonly
                                                    {% if scheduleData.thu[0] is not empty %}
                                                value="{{ scheduleData.thu[0] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col time_to">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="thursday_to"
                                                   data-day="4"
                                                   placeholder="To"
                                                   readonly
                                                    {% if scheduleData.thu[0] is not empty %}
                                                value="{{ scheduleData.thu[1] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div id="friday" class="my-5 day" data-day="5">
                        <h4 class="row mx-2">
                            <div class="custom-control custom-switch">
                                <input type="checkbox" class="custom-control-input switch_day"
                                       data-day="5"
                                       {% if scheduleData.fri[0] is not empty %}checked{% endif %} id="switchFriday">
                                <label class="custom-control-label" for="switchFriday"></label>
                            </div>
                            Friday
                        </h4>
                        <div class="form-row day_container">
                            <div class="col time_from">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="friday_from"
                                                   data-day="5"
                                                   placeholder="From"
                                                   readonly
                                                    {% if scheduleData.fri[0] is not empty %}
                                                value="{{ scheduleData.fri[0] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col time_to">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="friday_to"
                                                   data-day="5"
                                                   placeholder="To"
                                                   readonly
                                                    {% if scheduleData.fri[0] is not empty %}
                                                value="{{ scheduleData.fri[1] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div id="saturday" class="my-5 day" data-day="6">
                        <h4 class="row mx-2">
                            <div class="custom-control custom-switch">
                                <input type="checkbox" class="custom-control-input switch_day"
                                       data-day="6"
                                       {% if scheduleData.sat[0] is not empty %}checked{% endif %} id="switchSaturday">
                                <label class="custom-control-label" for="switchSaturday"></label>
                            </div>
                            Saturday
                        </h4>
                        <div class="form-row day_container">
                            <div class="col time_from">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="saturday_from"
                                                   data-day="6"
                                                   placeholder="From"
                                                   readonly
                                                    {% if scheduleData.sat[0] is not empty %}
                                                value="{{ scheduleData.sat[0] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col time_to">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="saturday_to"
                                                   data-day="6"
                                                   placeholder="To"
                                                   readonly
                                                    {% if scheduleData.sat[0] is not empty %}
                                                value="{{ scheduleData.sat[1] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div id="sunday" class="my-5 day" data-day="7">
                        <h4 class="row mx-2">
                            <div class="custom-control custom-switch">
                                <input type="checkbox" class="custom-control-input switch_day"
                                       data-day="7"
                                       {% if scheduleData.sun[0] is not empty %}checked{% endif %} id="switchSunday">
                                <label class="custom-control-label" for="switchSunday"></label>
                            </div>
                            Sunday
                        </h4>
                        <div class="form-row day_container">
                            <div class="col time_from">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="sunday_from"
                                                   data-day="7"
                                                   placeholder="From"
                                                   readonly
                                                    {% if scheduleData.sun[0] is not empty %}
                                                value="{{ scheduleData.sun[0] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col time_to">
                                <div class="input-group time">
                                    <div class="form-group">
                                        <div class="input-group timepicker">
                                            <input type="text" class="form-control select_time"
                                                   name="sunday_to"
                                                   data-day="7"
                                                   placeholder="To"
                                                   readonly
                                                    {% if scheduleData.sun[0] is not empty %}
                                                value="{{ scheduleData.sun[1] | trim }}"
                                                    {% endif %}>
                                            <span class="input-group-addon">
                                                <div class="input-group-append">
                                                    <span class="fa fa-clock-o input-group-text"></span>
                                                </div>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <button type="submit" class="btn btn-primary">Change supplier schedule</button>
                </form>
            </div>
        {% endif %}
    </div>

    <script src="{{ asset('assets/js/functions/ajax.js') }}"></script>

    <script>
        const selectSupplier = (() => {
            document.querySelector('#selectSupplier').addEventListener('change', e => {
                const supplierUrl = e.target.value;
                location.replace(supplierUrl);
            });
        })();

        const displayScheduleDayForms = (() => {
            document.querySelectorAll('.switch_day').forEach(item => {
                if (!item.checked) {
                    item.closest('.day').querySelector('.day_container').classList.add('d-none');
                }
            });
        })();

        const switchDay = (() => {
            document.querySelectorAll('.switch_day').forEach(item => {
                item.addEventListener('change', e => {
                    const day = e.target.dataset.day;
                    const dayContainer = document.querySelector(`.day[data-day="${day}"]`).querySelector('.day_container');

                    const timeFrom = dayContainer.querySelector('.time_from .select_time');

                    const timeTo = dayContainer.querySelector('.time_to .select_time');

                    if (!e.target.checked) {
                        timeFrom.setAttribute('data-value', timeFrom.value);
                        timeFrom.value = '';

                        timeTo.setAttribute('data-value', timeTo.value);
                        timeTo.value = '';

                        dayContainer.classList.add('d-none');
                    } else {
                        timeFrom.setAttribute('value', timeFrom.dataset.value);
                        timeFrom.setAttribute('data-value', '');

                        timeTo.setAttribute('value', timeTo.dataset.value);
                        timeTo.setAttribute('data-value', '');

                        dayContainer.classList.remove('d-none');
                    }
                })
            });
        })();

        const checkExist = (() => {
            const check = setTimeout(function () {
                document.querySelectorAll('.select_time').forEach(item => {
                    if (item.value === '') {
                        item.value = '';
                    }
                });
                clearTimeout(check);
            }, 10);
        })();

        const timePicker = (() => {
            const defaults = {
                showClear: true,
                showClose: true,
                allowInputToggle: true,
                ignoreReadonly: true,
                toolbarPlacement: 'top',
                locale: 'nl',
                icons: {
                    time: 'fa fa-clock-o',
                    date: 'fa fa-calendar',
                    up: 'fa fa-angle-up',
                    down: 'fa fa-angle-down',
                    previous: 'fa fa-angle-left',
                    next: 'fa fa-angle-right',
                    today: 'fa fa-dot-circle-o',
                    clear: 'fa fa-trash',
                    close: 'fa fa-times'
                }
            };
            const optionsTime = $.extend({}, defaults, {format: 'HH:mm'});
            $('.timepicker').datetimepicker(optionsTime);
        })();

        document.querySelectorAll('.select_time').forEach(item => {
            item.addEventListener('blur', e => {
                console.log(e.target)
                const parent = document.querySelector(`.day[data-day="${e.target.dataset.day}"]`);
                const dayFrom = parent.querySelector('.time_from .select_time');
                const dayTo = parent.querySelector('.time_to .select_time');
                const hmFrom = dayFrom.value;
                const hmTo = dayTo.value;
                const splitTimeDayFrom = hmFrom.split(':');
                const splitTimeDayTo = hmTo.split(':');
                const secondsFrom = (+splitTimeDayFrom[0]) * 60 * 60 + (+splitTimeDayFrom[1]) * 60;
                const secondsTo = (+splitTimeDayTo[0]) * 60 * 60 + (+splitTimeDayTo[1]) * 60;

                let differenceInTime = 0;
                if (!isNaN(secondsFrom) && !isNaN(secondsTo)) {
                    differenceInTime = secondsFrom - secondsTo;
                }
                if (differenceInTime > 0) {
                    e.target.value = '';
                    alert('The start time of the working day cannot exceed the time of the end of the working day!');
                }

            });
        });
    </script>


    <style>
        .datepicker .form-control,
        .timepicker .form-control,
        .datetimepicker .form-control {
            background: #fff;
        }
    </style>
{% endblock %}
